/********************************************************************/
/*                                                                  */
/*                   AutoMap/AutoLink Users' Manual                 */
/*                                                                  */
/*    Example of sending with AutoLink an array of linked-lists     */
/*                                                                  */
/* Creation date............April 21 2000                           */
/* Last modification date...May   18 2000                           */
/*                                                                  */
/* Author : Olivier NICOLAS (olivier.nicolas@nist.gov)              */
/*          Guest researcher at NIST                                */
/*                                                                  */
/********************************************************************/
#ifndef PERF_
#define PERF_

#define ARRAY_SIZE   4
#define LISTS_LENGHT 3

/*~ AM_Begin */
typedef struct elementT elementT /*~ AM */;
typedef struct pArrayT pArrayT /*~ AM */;

struct elementT
{
  int  value1;
  int  value2;
  char name[11];
  elementT *next;
};

struct pArrayT
{
  elementT *array[ARRAY_SIZE];
};
/*~ AM_End */

void createData();
void freeData(int rank);
void printData(int rank);
void sendData(int rank, int sendTo);
void recvData(int rank, int recvFrom);
void printList(elementT *elm, int num);
void freeList(elementT *elm);

#endif /* PERF_ */
