/********************************************************************/
/*                                                                  */
/*                   AutoMap/AutoLink Users' Manual                 */
/*                                                                  */
/*                        A concrete example                        */
/*                                                                  */
/*             From a Generic Genetic Programming Project           */
/*                                                                  */
/*       Sending of the initial population of genetic programs      */
/*                          with AutoLink                           */
/*                                                                  */
/* Creation date............April 21 2000                           */
/* Last modification date...May   18 2000                           */
/*                                                                  */
/* Author : Olivier NICOLAS (olivier.nicolas@nist.gov)              */
/*          Guest researcher at NIST                                */
/*                                                                  */
/********************************************************************/
/*                                                                  */
/*   Management of the individuals (also called Genetic Programs)   */
/*                                                                  */
/********************************************************************/
#include "population.h"
#include "individual.h"
#include "eval.h"
#include "node.h"

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

void printProg(FILE *stream, individualT *prog)
{
  int subTreeNb;

  fprintf(stream, "Printing INDIVIDUAL\n");fflush(stream);

  for (subTreeNb=0; subTreeNb<NB_TREES; subTreeNb++)
    {
      fprintf(stream, "\t %s : ", prog->subTree[subTreeNb]->name);fflush(stream);
      printTree(stream, prog->subTree[subTreeNb]->root, subTreeNb);
      fprintf(stream, "\n");
    }
  
  fprintf(stream, "\n");fflush(stream);
}

void freeIndividual(individualT *prog)
{
  int subTreeNb;

  for (subTreeNb=0; subTreeNb<NB_TREES; subTreeNb++)
    {
      freeNode(prog->subTree[subTreeNb]->root, subTreeNb);
      free(prog->subTree[subTreeNb]);
    }
  
  free(prog);
}
