/********************************************************************/
/*                                                                  */
/*                   AutoMap/AutoLink Users' Manual                 */
/*                                                                  */
/*                        A concrete example                        */
/*                                                                  */
/*             From a Generic Genetic Programming Project           */
/*                                                                  */
/*       Sending of the initial population of genetic programs      */
/*                          with AutoLink                           */
/*                                                                  */
/* Creation date............April 21 2000                           */
/* Last modification date...May   18 2000                           */
/*                                                                  */
/* Author : Olivier NICOLAS (olivier.nicolas@nist.gov)              */
/*          Guest researcher at NIST                                */
/*                                                                  */
/********************************************************************/
/*                                                                  */
/*   Management of the individuals (also called Genetic Programs)   */
/*                                                                  */
/********************************************************************/
#ifndef INDIVIDUAL_
#define INDIVIDUAL_

#include "problemParams.def"
#include "node.h"
#include "eval.h"

#include <stdio.h>

typedef struct individualT individualT;

struct individualT
{
  long time;
  evalT evaluationResults;
  treeT *subTree[NB_TREES];
};


void printProg(FILE *stream, individualT *prog);
void freeIndividual(individualT *prog);

#endif /* INDIVIDUAL_ */
