/********************************************************************/
/*                                                                  */
/*                   AutoMap/AutoLink Users' Manual                 */
/*                                                                  */
/*                        A concrete example                        */
/*                                                                  */
/*             From a Generic Genetic Programming Project           */
/*                                                                  */
/*       Sending of the initial population of genetic programs      */
/*                          with AutoLink                           */
/*                                                                  */
/* Creation date............April 21 2000                           */
/* Last modification date...May   18 2000                           */
/*                                                                  */
/* Author : Olivier NICOLAS (olivier.nicolas@nist.gov)              */
/*          Guest researcher at NIST                                */
/*                                                                  */
/********************************************************************/
/*                                                                  */
/*                 Sub-trees management functions                   */
/*                                                                  */
/********************************************************************/
#ifndef NODE_
#define NODE_

#include "macros.h"
#include "problemParams.def"

#include <stdio.h>

typedef struct nodeT     nodeT;
typedef struct treeT     treeT;

struct nodeT
{
  int entryPoints;           /* nb of points elligible for crossover or mutation */
  int depth;                 /* depth of the sub-tree                            */
  int op;                    /* Operation code                                   */
  DATATYPE value;            /* immediate value when applicable                  */
  nodeT *arguments[MAX_ARG]; /* pointers to the args -- if any                   */
};

struct treeT
{
  nodeT *root;
  char name[15];
};


/* The methods */
int rank(nodeT *node, int subTreeNb);
nodeT *produceBranch();
nodeT *createNode(int op);
void freeNode(nodeT *node, int tree);
void printTree(FILE *stream, nodeT *node, int tree);

#endif /* NODE_ */
