/********************************************************************/
/*                                                                  */
/*                   AutoMap/AutoLink Users' Manual                 */
/*                                                                  */
/*                        A concrete example                        */
/*                                                                  */
/*             From a Generic Genetic Programming Project           */
/*                                                                  */
/*       Sending of the initial population of genetic programs      */
/*                          with AutoLink                           */
/*                                                                  */
/* Creation date............April 21 2000                           */
/* Last modification date...May   18 2000                           */
/*                                                                  */
/* Author : Olivier NICOLAS (olivier.nicolas@nist.gov)              */
/*          Guest researcher at NIST                                */
/*                                                                  */
/********************************************************************/
/*                                                                  */
/*                    Management of the population                  */
/*                                                                  */
/********************************************************************/
#ifndef POPULATION_
#define POPULATION_

#include "eval.h"
#include "individual.h"
#include "runParams.def"

typedef struct populationT
{
  evalT outOfSampleResults; /* results of the best individual of a */
                            /* generation on an out-of-sample set  */
  individualT *individuals[POPULATION_SIZE];
}populationT;

extern populationT population;

void createInitialPopulation();
void freePopulation();

#endif /* POPULATION_ */
