/********************************************************************/
/*                                                                  */
/*                   AutoMap/AutoLink Users' Manual                 */
/*                                                                  */
/*                        A concrete example                        */
/*                                                                  */
/*             From a Generic Genetic Programming Project           */
/*                                                                  */
/*       Sending of the initial population of genetic programs      */
/*                          with AutoLink                           */
/*                                                                  */
/* Creation date............April 21 2000                           */
/* Last modification date...May   18 2000                           */
/*                                                                  */
/* Author : Olivier NICOLAS (olivier.nicolas@nist.gov)              */
/*          Guest researcher at NIST                                */
/*                                                                  */
/********************************************************************/
/*                                                                  */
/*         Specification of the language for Genetic Programs       */
/*                                                                  */
/********************************************************************/
#include "spec.h"
#include "defines.h"

/* For each sub-tree composing the programs, specify the number          */
/* different available nodes. (Ex : int dimensions[NB_TREES] = {15, 12}; */

int dimensions[NB_TREES] = {20, 20, 20};

struct tree_spec Trees[NB_TREES] = 
{
  {
    "C0",	
    { { f_add,   "+",     FCT_2},
      { f_sub,   "-",     FCT_2},
      { f_mul,   "*",     FCT_2},
      { f_mod,   "%",     FCT_2},
      { f_iflt,  "IFLT",  FCT_4},
      { f_rint,  "RINT",  LEAF},
      { f_cst0,  "CST0",  LEAF},
      { f_cst1,  "CST1",  LEAF},
      { f_cst2,  "CST2",  LEAF},
      { f_is0,   "is0",   FCT_3},
      { f_is1,   "is1",   FCT_3},
      { f_is2,   "is2",   FCT_3},
      { f_index, "index", LEAF},
      { f_digit, "digit", FCT_1},
      { f_n0,    "N0",    LEAF},
      { f_n1,    "N1",    LEAF},
      { f_n2,    "N2",    LEAF},
      { f_p0,    "P0",    LEAF},
      { f_p1,    "P1",    LEAF},
      { f_p2,    "P2",    LEAF}
    }   
  },
  {
    "C1",	
    { { f_add,   "+",     FCT_2},
      { f_sub,   "-",     FCT_2},
      { f_mul,   "*",     FCT_2},
      { f_mod,   "%",     FCT_2},
      { f_iflt,  "IFLT",  FCT_4},
      { f_rint,  "RINT",  LEAF},
      { f_cst0,  "CST0",  LEAF},
      { f_cst1,  "CST1",  LEAF},
      { f_cst2,  "CST2",  LEAF},
      { f_is0,   "is0",   FCT_3},
      { f_is1,   "is1",   FCT_3},
      { f_is2,   "is2",   FCT_3},
      { f_index, "index", LEAF},
      { f_digit, "digit", FCT_1},
      { f_n0,    "N0",    LEAF},
      { f_n1,    "N1",    LEAF},
      { f_n2,    "N2",    LEAF},
      { f_p0,    "P0",    LEAF},
      { f_p1,    "P1",    LEAF},
      { f_p2,    "P2",    LEAF}
    }
  },
  {
    "C2",	
    { { f_add,   "+",     FCT_2},
      { f_sub,   "-",     FCT_2},
      { f_mul,   "*",     FCT_2},
      { f_mod,   "%",     FCT_2},
      { f_iflt,  "IFLT",  FCT_4},
      { f_rint,  "RINT",  LEAF},
      { f_cst0,  "CST0",  LEAF},
      { f_cst1,  "CST1",  LEAF},
      { f_cst2,  "CST2",  LEAF},
      { f_is0,   "is0",   FCT_3},
      { f_is1,   "is1",   FCT_3},
      { f_is2,   "is2",   FCT_3},
      { f_index, "index", LEAF},
      { f_digit, "digit", FCT_1},
      { f_n0,    "N0",    LEAF},
      { f_n1,    "N1",    LEAF},
      { f_n2,    "N2",    LEAF},
      { f_p0,    "P0",    LEAF},
      { f_p1,    "P1",    LEAF},
      { f_p2,    "P2",    LEAF}
    }
  }
};
