/********************************************************************/
/*                                                                  */
/*                   AutoMap/AutoLink Users' Manual                 */
/*                                                                  */
/*                        A concrete example                        */
/*                                                                  */
/*             From a Generic Genetic Programming Project           */
/*                                                                  */
/*       Sending of the initial population of genetic programs      */
/*                          with AutoLink                           */
/*                                                                  */
/* Creation date............April 21 2000                           */
/* Last modification date...May   18 2000                           */
/*                                                                  */
/* Author : Olivier NICOLAS (olivier.nicolas@nist.gov)              */
/*          Guest researcher at NIST                                */
/*                                                                  */
/********************************************************************/
/*                                                                  */
/*                    Management of the population                  */
/*                                                                  */
/********************************************************************/
#include "population.h"
#include "limit.h"
#include "individual.h"
#include "randomizer.h"
#include "node.h"
#include "spec.h"
#include "eval.h"

#include <stdlib.h>

populationT *population;
individualT **currentIndividual;

void createInitialPopulation()
{
  int i, subTreeNb;

  population = malloc(sizeof(populationT));

  for (i=0, currentIndividual = &population->individuals[0]; i<POPULATION_SIZE; i++, currentIndividual++)
    {
      *currentIndividual = malloc(sizeof(individualT));

      for (subTreeNb=0; subTreeNb<NB_TREES; subTreeNb++)
	{
	  (*currentIndividual)->subTree[subTreeNb] = malloc (sizeof(treeT));
	  (*currentIndividual)->subTree[subTreeNb]->root = produceBranch(depthLimit[subTreeNb], subTreeNb);
	  strcpy((*currentIndividual)->subTree[subTreeNb]->name, Trees[subTreeNb].name);
	}
    }
}

void freePopulation()
{
  int i;

  for (i=0, currentIndividual = &population->individuals[0]; i<POPULATION_SIZE; i++)
    freeIndividual(*currentIndividual++);

  free(population);
}
