/********************************************************************/
/*                                                                  */
/*                   AutoMap/AutoLink Users' Manual                 */
/*                                                                  */
/*                        A concrete example                        */
/*                                                                  */
/*             From a Generic Genetic Programming Project           */
/*                                                                  */
/*       Sending of the initial population of genetic programs      */
/*                          with AutoLink                           */
/*                                                                  */
/* Creation date............April 21 2000                           */
/* Last modification date...May   18 2000                           */
/*                                                                  */
/* Author : Olivier NICOLAS (olivier.nicolas@nist.gov)              */
/*          Guest researcher at NIST                                */
/*                                                                  */
/********************************************************************/
/*                                                                  */
/*         Specification of the language for Genetic Programs       */
/*                                                                  */
/********************************************************************/
#ifndef SPEC_
#define SPEC_

#include "limit.h"
#include "defines.h"

#define CONST    -1

typedef struct node_spec
{
  int id;
  char *name;
  int arity;
}node_spec;

typedef struct tree_spec
{
  char *name;
  node_spec Nodes[NB_NODES_MAX];
}tree_spec;

extern struct tree_spec Trees[NB_TREES];
extern int dimensions[NB_TREES];

#endif /* SPEC_ */
