/********************************************************************/
/*                                                                  */
/*                   AutoMap/AutoLink Users' Manual                 */
/*                                                                  */
/*                        A concrete example                        */
/*                                                                  */
/*             From a Generic Genetic Programming Project           */
/*                                                                  */
/*       Sending of the initial population of genetic programs      */
/*                          with AutoLink                           */
/*                                                                  */
/* Creation date............April 21 2000                           */
/* Last modification date...May   18 2000                           */
/*                                                                  */
/* Author : Olivier NICOLAS (olivier.nicolas@nist.gov)              */
/*          Guest researcher at NIST                                */
/*                                                                  */
/********************************************************************/
/*                                                                  */
/*                       Timing functions                           */
/*                                                                  */
/********************************************************************/
#include "timer.h"

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <sys/timeb.h>

struct timeb *tpBegin;
struct timeb *tpEnd;
struct tm *tmBegin;
struct tm *tmEnd;
unsigned int beginTime;
unsigned int endTime;


void initTimer()
{
  tpBegin = malloc(sizeof(*tpBegin));
  tpEnd = malloc(sizeof(*tpEnd));
  tmBegin = malloc(sizeof(*tmBegin));
  tmEnd = malloc(sizeof(*tmEnd));
}

void beginTimer()
{
  ftime(tpBegin);
}

unsigned int endTimer()
{
  ftime(tpEnd);

  //for portability, should use localtime, instead of localtime_r
  //But, localtime returns a pointer to a static data.
  //Should then make a copy of data return by localtime!
  localtime_r(&tpBegin->time, tmBegin);
  localtime_r(&tpEnd->time, tmEnd);

  beginTime = tpBegin->millitm + 1000*(tmBegin->tm_sec + 60*(tmBegin->tm_min + 60*tmBegin->tm_hour));
  endTime = tpEnd->millitm + 1000*(tmEnd->tm_sec + 60*(tmEnd->tm_min + 60*tmEnd->tm_hour));

  return(endTime-beginTime); 
}

void freeTimer()
{
  free(tpBegin);
  free(tpEnd);
  free(tmBegin);
  free(tmEnd);
}
