/********************************************************************/
/*                                                                  */
/*                   AutoMap/AutoLink Users' Manual                 */
/*                                                                  */
/*                        A concrete example                        */
/*                                                                  */
/*             From a Generic Genetic Programming Project           */
/*                                                                  */
/*       Sending of the initial population of genetic programs      */
/*                          with AutoLink                           */
/*                                                                  */
/* Creation date............April 21 2000                           */
/* Last modification date...May   18 2000                           */
/*                                                                  */
/* Author : Olivier NICOLAS (olivier.nicolas@nist.gov)              */
/*          Guest researcher at NIST                                */
/*                                                                  */
/********************************************************************/
/*                                                                  */
/*                   File to pass to AutoMap                        */
/*   Contains all the data-structures definitions for the program   */
/*                                                                  */
/********************************************************************/
#ifndef STRUCT_
#define STRUCT_

#include "macros.h"
#include "problemParams.def"

/*~ AM_Begin */

typedef struct statT       statT       /*~ AM */;
typedef struct nodeT       nodeT       /*~ AM */;
typedef struct evalT       evalT       /*~ AM */;
typedef struct treeT       treeT       /*~ AM */;
typedef struct individualT individualT /*~ AM */;
typedef struct populationT populationT /*~ AM */;

struct statT
{
  int n;
};

struct nodeT
{
  int entryPoints;
  int depth;
  int op;
  int value;
  nodeT *arguments[MAX_ARG];
};

struct evalT
{
  int hits;
  float correlation;
  float standardizedFitness;  
  statT statistics;
};

struct treeT
{
  nodeT *root;
  char name[15];
};

struct individualT
{
  long time;
  evalT evaluationResults;
  treeT *subTree[NB_TREES];
};


struct populationT
{
  evalT outOfSampleResults;
  individualT *individuals[POPULATION_SIZE];
}populationT;

/*~ AM_End */

#endif /* STRUCT_ */
