/********************************************************************/
/*                                                                  */
/*                   AutoMap/AutoLink Users' Manual                 */
/*                                                                  */
/*  This is the basic example used in the manual to explain how to  */
/*                          use AutoLink                            */
/*                                                                  */
/* Creation date............April 21 2000                           */
/* Last modification date...May   18 2000                           */
/*                                                                  */
/* Author : Olivier NICOLAS (olivier.nicolas@nist.gov)              */
/*          Guest researcher at NIST                                */
/*                                                                  */
/********************************************************************/
#include "short.h"
#include "mpi.h"
#include "autolink.inc"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

element *myElement;

int main(int argc,char* argv[])
{
  int my_rank;
  int num_ranks;

  MPI_Init(&argc ,&argv);
  AL_Init(-1);

  MPI_Comm_rank(MPI_COMM_WORLD, &my_rank);    /* get rank */
  MPI_Comm_size(MPI_COMM_WORLD, &num_ranks);  /* get number of ranks */
  

  if (my_rank == 0) 
    {
      int sendTo = 1;

      myElement = malloc(sizeof(element));
      myElement->dataElement = malloc(sizeof(data));
      myElement->dataElement->value = 15;
      
      if (AL_Send(myElement, AL_element, sendTo, 0, MPI_COMM_WORLD)!= MPI_SUCCESS)
	{
	  printf("Error in Sending");
	  exit(1);
	}
    } 
  else 
    {
      int recvFrom = 0;
      MPI_Status status;
      int type;

      if (AL_Recv((void *) &myElement, &type, recvFrom, 0, MPI_COMM_WORLD, &status, NULL) != MPI_SUCCESS) 
	{
	  printf("Error in Receiving");
	  exit(1);
	}

      printf("Rank[1] Value received : %d\n", myElement->dataElement->value);
    } 
  
  printf("Rank[%d] ... Finalizing\n", my_rank);
  MPI_Finalize();
  AL_Finalize();

  return (0);
}
