/********************************************************************/
/*                                                                  */
/*                   AutoMap/AutoLink Users' Manual                 */
/*                                                                  */
/*               Example on sending an array of arrays              */
/*                                                                  */
/* Creation date............April 21 2000                           */
/* Last modification date...May   18 2000                           */
/*                                                                  */
/* Author : Olivier NICOLAS (olivier.nicolas@nist.gov)              */
/*          Guest researcher at NIST                                */
/*                                                                  */
/********************************************************************/
#ifndef ARRAYOFARRAYS_
#define ARRAYOFARRAYS_

#define ARRAY_SIZE       3
#define INT_ARRAY_SIZE   7
#define CHAR_ARRAY_SIZE  5
#define FLOAT_ARRAY_SIZE 2

/*~ AM_Begin */
typedef struct elementT elementT /*~ AM */;
typedef struct pArrayT pArrayT /*~ AM */;

struct elementT
{
  int  intValues[INT_ARRAY_SIZE];
  char name[CHAR_ARRAY_SIZE];
  float floatValues[FLOAT_ARRAY_SIZE];
};

struct pArrayT
{
  elementT array[ARRAY_SIZE];
};
/*~ AM_End */

void createData();
void freeData(int rank);
void printData(int rank);
void sendData(int rank, int sendTo);
void recvData(int rank, int recvFrom);

#endif /* ARRAYOFARRAYS_ */
