/********************************************************************/
/*                                                                  */
/*                  AutoMap/AutoLink Users' Manual                  */
/*                                                                  */
/*          Example on sending an array of "struct element"         */
/*   This program is for you to check if your MPI version suffers   */
/*                    from the padding problem                      */
/*                                                                  */
/* Creation date............April 21 2000                           */
/* Last modification date...May   18 2000                           */
/*                                                                  */
/* Author : Olivier NICOLAS (olivier.nicolas@nist.gov)              */
/*          Guest researcher at NIST                                */
/*                                                                  */
/********************************************************************/
#ifndef PADDINGBUG_
#define PADDINGBUG_

#define ARRAY_SIZE 2

/*~ AM_Begin */

typedef struct element1T element1T /*~ AM */;
typedef struct element2T element2T /*~ AM */;
typedef struct pArray1T pArray1T /*~ AM */;
typedef struct pArray2T pArray2T /*~ AM */;

struct element1T
{
  int  value;
  char name[5];
  float value2;
};

struct element2T
{
  int  value;
  char name[5];
  float value2;
};

struct pArray1T
{
  element1T population[ARRAY_SIZE];
};

struct pArray2T
{
  element2T population[ARRAY_SIZE];
};

/*~ AM_End */

void createData();
void freeData(int rank);
void printData(int rank);
void sendData(int rank, int sendTo);
void recvData(int rank, int recvFrom);

#endif /* PADDINGBUG_ */
