#define __MPITYPES_INC__
#include "padtypes.h"

void
Build_MPI_Types()
{

  element1T Type0;
  element2T Type1;
  pArray1T Type2;
  pArray2T Type3;

  MPI_Aint          disp[_AM_MaxFields];
  MPI_Datatype      type[_AM_MaxFields];
  int               blocklen[_AM_MaxFields];
  int               i;

 /* element1T */

  MPI_Address(&Type0.value,	&disp[0]);
  MPI_Address(Type0.name,	&disp[1]);
  MPI_Address(&Type0.value2,	&disp[2]);

  type[0] = MPI_INT;
  type[1] = MPI_CHAR;
  type[2] = MPI_FLOAT;

  for (i = 2; i >= 0; i--)
    disp[i] -= disp[0];

  blocklen[0] = 1;
  blocklen[1] = 1*(5);
  blocklen[2] = 1;

  MPI_Type_struct(3, blocklen, disp, type, &AM_element1T);
  MPI_Type_commit(&AM_element1T);

 /* element2T */

  MPI_Address(&Type1.value,	&disp[0]);
  MPI_Address(Type1.name,	&disp[1]);
  MPI_Address(&Type1.value2,	&disp[2]);

  type[0] = MPI_INT;
  type[1] = MPI_CHAR;
  type[2] = MPI_FLOAT;

  for (i = 2; i >= 0; i--)
    disp[i] -= disp[0];

  blocklen[0] = disp[1] / sizeof(int);
  blocklen[1] = (disp[2] - disp[1]) / sizeof(char);
  blocklen[2] = (sizeof(element2T) - disp[2]) / sizeof(float);

  MPI_Type_struct(3, blocklen, disp, type, &AM_element2T);
  MPI_Type_commit(&AM_element2T);

 /* pArray1T */

  MPI_Address(Type2.population,	&disp[0]);

  type[0] = AM_element1T;

  for (i = 0; i >= 0; i--)
    disp[i] -= disp[0];

  blocklen[0] = 1*(TEST_ARRAY_SIZE);

  MPI_Type_struct(1, blocklen, disp, type, &AM_pArray1T);
  MPI_Type_commit(&AM_pArray1T);

 /* pArray2T */

  MPI_Address(Type3.population,	&disp[0]);

  type[0] = AM_element2T;

  for (i = 0; i >= 0; i--)
    disp[i] -= disp[0];

  blocklen[0] = sizeof(pArray2T) / sizeof(element2T);

  MPI_Type_struct(1, blocklen, disp, type, &AM_pArray2T);
  MPI_Type_commit(&AM_pArray2T);

}

void
Free_MPI_Types()
{
  MPI_Type_free(&AM_element1T);
  MPI_Type_free(&AM_element2T);
  MPI_Type_free(&AM_pArray1T);
  MPI_Type_free(&AM_pArray2T);
}
