/**********************************************************/
/*                                                        */
/*     AutoMap / AutoLink 3.00 b1                         */
/*                                                        */
/*  version 1.1                                           */
/*  Eric Baland (AutoMap)                                 */
/*  & Koen Vrielink (AutoLink)                            */
/*    January 1997                                        */
/*                                                        */
/*  Version 2.0                                           */
/*  Jasper Peeters (AutoLink)                             */
/*    July 1997                                           */
/*                                                        */
/*  Version 2.1                                           */
/*  Martial MICHEL (AutoMap & AutoLink :                  */
/*                    Concept & Programation)             */
/*  & Delphine GOUJON (AutoLink : Concept)                */
/*    July 1998                                           */
/*                                                        */
/*  Version 2.11                                          */
/*  Martial MICHEL                                        */
/*  & Thibaut ROUFFINEAU (Testing)                        */
/*    November 1998                                       */
/*                                                        */
/*  Version 2.11.1                                        */
/*  Martial MICHEL                                        */
/*    January 1999                                        */
/*                                                        */
/*  Version 2.20                                          */
/*  Martial MICHEL                                        */
/*    June 1999                                           */
/*                                                        */
/*  Version 3.00b1                                        */
/*  Martial MICHEL                                        */
/*  & Olivier NICOLAS (Testing & AutoMap : Concept)       */
/*    April 2000                                          */
/*                                                        */
/*                                                        */
/**********************************************************/



#if 0
static char _mpitypes_inc_[] =
"@(#)[AutoMap 3.00 [beta 1]] AutoMap MPI Types (created by '/home/martial/Systems/IRIX/bin/AutoMap -noAL paddingTest.h' on '')";
#endif

#define __MPITYPES_INC__

#include "mpitypes.h"

void
Build_MPI_Types()
{

  elementT Type0;
  pArrayT Type1;

  MPI_Aint          disp[_AM_MaxFields];
  MPI_Datatype      type[_AM_MaxFields];
  int               blocklen[_AM_MaxFields];
  int               i;

 /* elementT */

  MPI_Address(&Type0.value,	&disp[0]);
  MPI_Address(Type0.name,	&disp[1]);
  MPI_Address(&Type0.value2,	&disp[2]);

  type[0] = MPI_INT;
  type[1] = MPI_CHAR;
  type[2] = MPI_FLOAT;

  for (i = 2; i >= 0; i--)
    disp[i] -= disp[0];

#ifndef AM_PC
  blocklen[0] = 1;
  blocklen[1] = 1*(5);
  blocklen[2] = 1;
#else
  blocklen[0] = disp[1] / sizeof(int);
  blocklen[1] = (disp[2] - disp[1]) / sizeof(char);
  blocklen[2] = (sizeof(elementT) - disp[2]) / sizeof(float);
#endif

  MPI_Type_struct(3, blocklen, disp, type, &AM_elementT);
  MPI_Type_commit(&AM_elementT);

 /* pArrayT */

  MPI_Address(Type1.population,	&disp[0]);

  type[0] = AM_elementT;

  for (i = 0; i >= 0; i--)
    disp[i] -= disp[0];

#ifndef AM_PC
  blocklen[0] = 1*(ARRAY_SIZE);
#else
  blocklen[0] = sizeof(pArrayT) / sizeof(elementT);
#endif

  MPI_Type_struct(1, blocklen, disp, type, &AM_pArrayT);
  MPI_Type_commit(&AM_pArrayT);

}

void
Free_MPI_Types()
{
  MPI_Type_free(&AM_elementT);
  MPI_Type_free(&AM_pArrayT);
}
