/********************************************************************/
/*                                                                  */
/*                  AutoMap/AutoLink Users' Manual                  */
/*                                                                  */
/*          This program aims to teach you how to pass-by           */
/*                      the padding problem                         */
/*                                                                  */
/* Creation date............April 21 2000                           */
/* Last modification date...May   18 2000                           */
/*                                                                  */
/* Author : Olivier NICOLAS (olivier.nicolas@nist.gov)              */
/*          Guest researcher at NIST                                */
/*                                                                  */
/********************************************************************/
#include "mpi.h"
#include "mpitypes.inc"
#include "paddingTest.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


pArrayT myPopulation;

void sendData(int rank, int sendTo)
{
  if (MPI_Send(&myPopulation, 1, AM_pArrayT, sendTo, 0, MPI_COMM_WORLD)!= MPI_SUCCESS)
    {
      printf("Error in Sending");
      exit(1);
    }
}

void recvData(int rank, int recvFrom)
{
  MPI_Status status;
  
  if (MPI_Recv(&myPopulation, 1, AM_pArrayT, recvFrom, 0, MPI_COMM_WORLD, &status) != MPI_SUCCESS) 
    {
      printf("Error in Receiving");
      exit(1);
    }
}


int main(int argc,char* argv[])
{
  int my_rank;
  int num_ranks;

  MPI_Init(&argc ,&argv);
  Build_MPI_Types();

  MPI_Comm_rank(MPI_COMM_WORLD, &my_rank);    /* get rank */
  MPI_Comm_size(MPI_COMM_WORLD, &num_ranks);  /* get number of ranks */
  
  if (my_rank == 0) 
    {
      int sendTo = 1;

      strcpy(myPopulation.population[0].name, "ch11");
      strcpy(myPopulation.population[1].name, "ch12");

      printf("[%s]\n", myPopulation.population[1].name);

      sendData(my_rank, sendTo);
    } 
  else 
    {
      int recvFrom = 0;

      recvData(my_rank, recvFrom);
      printf("[%s]\n", myPopulation.population[1].name);
    } 
  
  MPI_Finalize();

  return (0);
}
