/********************************************************************/
/*                                                                  */
/*                  AutoMap/AutoLink Users' Manual                  */
/*                                                                  */
/*  This is the basic example used in the manual to explain how to  */
/*                          use AutoMap.                            */
/*                                                                  */
/* Creation date............April 21 2000                           */
/* Last modification date...May   18 2000                           */
/*                                                                  */
/* Author : Olivier NICOLAS (olivier.nicolas@nist.gov)              */
/*          Guest researcher at NIST                                */
/*                                                                  */
/********************************************************************/
#include "short.h"
#include "mpi.h"
#include "mpitypes.inc"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

element myElement;

int main(int argc,char* argv[])
{
  int my_rank;
  int num_ranks;

  MPI_Init(&argc ,&argv);
  Build_MPI_Types();

  MPI_Comm_rank(MPI_COMM_WORLD, &my_rank);    /* get rank */
  MPI_Comm_size(MPI_COMM_WORLD, &num_ranks);  /* get number of ranks */
  
  if (my_rank == 0) 
    {
      int sendTo = 1;

      myElement.value = 15;
      
      if (MPI_Send(&myElement, 1, AM_element, sendTo, 0, MPI_COMM_WORLD)!= MPI_SUCCESS)
	{
	  printf("Error in Sending");
	  exit(1);
	}
      printf("Rank[0] Value sent......%d\n", myElement.value);
    } 
  else 
    {
      int recvFrom = 0;
      MPI_Status status;

      if (MPI_Recv(&myElement, 1, AM_element, recvFrom, 0, MPI_COMM_WORLD, &status) != MPI_SUCCESS) 
	{
	  printf("Error in Receiving");
	  exit(1);
	}

      printf("Rank[1] Value received..%d\n", myElement.value);
    } 
  
  MPI_Finalize();
  Free_MPI_Types();

  return (0);
}
