/********************************************************************/
/*                                                                  */
/*                   AutoMap/AutoLink Users' Manual                 */
/*                                                                  */
/* Creation date............April 21 2000                           */
/* Last modification date...May   18 2000                           */
/*                                                                  */
/* Author : Olivier NICOLAS (olivier.nicolas@nist.gov)              */
/*          Guest researcher at NIST                                */
/*                                                                  */
/********************************************************************/
/*                                                                  */
/*          Works like a printf; prints only if (Detail==1)         */
/*                                                                  */
/********************************************************************/
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

short Detail;

void myPrintf(char *fmt, ...)
{
  va_list pa;

  char *p, *vals;
  int vali;
  double vald;


  if (Detail == 1)
    {
      va_start(pa, fmt);
      
      for (p=fmt; *p; p++)
	{
	  if (*p!= '%')
	    {
	      putchar(*p);
	      continue;
	    }
	  switch (*++p)
	    {
	    case 'd' :
	      vali = va_arg(pa, int);
	      printf("%d", vali);
          break;
	    case 'f' :
	      vald = va_arg(pa, double);
	      printf("%f", vald);
	      break;
	    case 's' :
	      for (vals = va_arg(pa, char *); *vals; vals++)
		putchar(*vals);
	      break;
	    default :
	      putchar(*p);
	      break;
	    }
	}
      va_end(pa);
    }
}
